diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/aarf-wifi-manager.cc ns-3.34/src/wifi/model/rate-control/aarf-wifi-manager.cc
--- ns-3.33/src/wifi/model/rate-control/aarf-wifi-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/aarf-wifi-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,294 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2004,2005,2006 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#include "ns3/log.h"
+#include "aarf-wifi-manager.h"
+#include "ns3/wifi-tx-vector.h"
+
+#define Min(a,b) ((a < b) ? a : b)
+#define Max(a,b) ((a > b) ? a : b)
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("AarfWifiManager");
+
+/**
+ * \brief hold per-remote-station state for AARF Wifi manager.
+ *
+ * This struct extends from WifiRemoteStation struct to hold additional
+ * information required by the AARF Wifi manager
+ */
+struct AarfWifiRemoteStation : public WifiRemoteStation
+{
+  uint32_t m_timer; ///< timer
+  uint32_t m_success; ///< success
+  uint32_t m_failed; ///< failed
+  bool m_recovery; ///< recovery
+  uint32_t m_timerTimeout; ///< timer timeout
+  uint32_t m_successThreshold; ///< success threshold
+  uint8_t m_rate; ///< rate
+};
+
+NS_OBJECT_ENSURE_REGISTERED (AarfWifiManager);
+
+TypeId
+AarfWifiManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::AarfWifiManager")
+    .SetParent<WifiRemoteStationManager> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<AarfWifiManager> ()
+    .AddAttribute ("SuccessK", "Multiplication factor for the success threshold in the AARF algorithm.",
+                   DoubleValue (2.0),
+                   MakeDoubleAccessor (&AarfWifiManager::m_successK),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("TimerK",
+                   "Multiplication factor for the timer threshold in the AARF algorithm.",
+                   DoubleValue (2.0),
+                   MakeDoubleAccessor (&AarfWifiManager::m_timerK),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("MaxSuccessThreshold",
+                   "Maximum value of the success threshold in the AARF algorithm.",
+                   UintegerValue (60),
+                   MakeUintegerAccessor (&AarfWifiManager::m_maxSuccessThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("MinTimerThreshold",
+                   "The minimum value for the 'timer' threshold in the AARF algorithm.",
+                   UintegerValue (15),
+                   MakeUintegerAccessor (&AarfWifiManager::m_minTimerThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("MinSuccessThreshold",
+                   "The minimum value for the success threshold in the AARF algorithm.",
+                   UintegerValue (10),
+                   MakeUintegerAccessor (&AarfWifiManager::m_minSuccessThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddTraceSource ("Rate",
+                     "Traced value for rate changes (b/s)",
+                     MakeTraceSourceAccessor (&AarfWifiManager::m_currentRate),
+                     "ns3::TracedValueCallback::Uint64")
+  ;
+  return tid;
+}
+
+AarfWifiManager::AarfWifiManager ()
+  : WifiRemoteStationManager (),
+    m_currentRate (0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+AarfWifiManager::~AarfWifiManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+AarfWifiManager::DoInitialize ()
+{
+  NS_LOG_FUNCTION (this);
+  if (GetHtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HT rates");
+    }
+  if (GetVhtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support VHT rates");
+    }
+  if (GetHeSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HE rates");
+    }
+}
+
+WifiRemoteStation *
+AarfWifiManager::DoCreateStation (void) const
+{
+  NS_LOG_FUNCTION (this);
+  AarfWifiRemoteStation *station = new AarfWifiRemoteStation ();
+
+  station->m_successThreshold = m_minSuccessThreshold;
+  station->m_timerTimeout = m_minTimerThreshold;
+  station->m_rate = 0;
+  station->m_success = 0;
+  station->m_failed = 0;
+  station->m_recovery = false;
+  station->m_timer = 0;
+
+  return station;
+}
+
+void
+AarfWifiManager::DoReportRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+/**
+ * It is important to realize that "recovery" mode starts after failure of
+ * the first transmission after a rate increase and ends at the first successful
+ * transmission. Specifically, recovery mode transcends retransmissions boundaries.
+ * Fundamentally, ARF handles each data transmission independently, whether it
+ * is the initial transmission of a packet or the retransmission of a packet.
+ * The fundamental reason for this is that there is a backoff between each data
+ * transmission, be it an initial transmission or a retransmission.
+ *
+ * \param st the station that we failed to send Data
+ */
+void
+AarfWifiManager::DoReportDataFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AarfWifiRemoteStation *station = static_cast<AarfWifiRemoteStation*> (st);
+  station->m_timer++;
+  station->m_failed++;
+  station->m_success = 0;
+
+  if (station->m_recovery)
+    {
+      NS_ASSERT (station->m_failed >= 1);
+      if (station->m_failed == 1)
+        {
+          //need recovery fallback
+          station->m_successThreshold = (int)(Min (station->m_successThreshold * m_successK,
+                                                   m_maxSuccessThreshold));
+          station->m_timerTimeout = (int)(Max (station->m_timerTimeout * m_timerK,
+                                               m_minSuccessThreshold));
+          if (station->m_rate != 0)
+            {
+              station->m_rate--;
+            }
+        }
+      station->m_timer = 0;
+    }
+  else
+    {
+      NS_ASSERT (station->m_failed >= 1);
+      if (((station->m_failed - 1) % 2) == 1)
+        {
+          //need normal fallback
+          station->m_timerTimeout = m_minTimerThreshold;
+          station->m_successThreshold = m_minSuccessThreshold;
+          if (station->m_rate != 0)
+            {
+              station->m_rate--;
+            }
+        }
+      if (station->m_failed >= 2)
+        {
+          station->m_timer = 0;
+        }
+    }
+}
+
+void
+AarfWifiManager::DoReportRxOk (WifiRemoteStation *station,
+                               double rxSnr, WifiMode txMode)
+{
+  NS_LOG_FUNCTION (this << station << rxSnr << txMode);
+}
+
+void
+AarfWifiManager::DoReportRtsOk (WifiRemoteStation *station,
+                                double ctsSnr, WifiMode ctsMode, double rtsSnr)
+{
+  NS_LOG_FUNCTION (this << station << ctsSnr << ctsMode << rtsSnr);
+  NS_LOG_DEBUG ("station=" << station << " rts ok");
+}
+
+void
+AarfWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                 double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
+{
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  AarfWifiRemoteStation *station = static_cast<AarfWifiRemoteStation*> (st);
+  station->m_timer++;
+  station->m_success++;
+  station->m_failed = 0;
+  station->m_recovery = false;
+  NS_LOG_DEBUG ("station=" << station << " data ok success=" << station->m_success << ", timer=" << station->m_timer);
+  if ((station->m_success == station->m_successThreshold
+       || station->m_timer == station->m_timerTimeout)
+      && (station->m_rate < (GetNSupported (station) - 1)))
+    {
+      NS_LOG_DEBUG ("station=" << station << " inc rate");
+      station->m_rate++;
+      station->m_timer = 0;
+      station->m_success = 0;
+      station->m_recovery = true;
+    }
+}
+
+void
+AarfWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void
+AarfWifiManager::DoReportFinalDataFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+WifiTxVector
+AarfWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AarfWifiRemoteStation *station = static_cast<AarfWifiRemoteStation*> (st);
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  WifiMode mode = GetSupported (station, station->m_rate);
+  if (m_currentRate != mode.GetDataRate (channelWidth))
+    {
+      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
+      m_currentRate = mode.GetDataRate (channelWidth);
+    }
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+}
+
+WifiTxVector
+AarfWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  /// \todo we could/should implement the AARF algorithm for
+  /// RTS only by picking a single rate within the BasicRateSet.
+  AarfWifiRemoteStation *station = static_cast<AarfWifiRemoteStation*> (st);
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  WifiTxVector rtsTxVector;
+  WifiMode mode;
+  if (GetUseNonErpProtection () == false)
+    {
+      mode = GetSupported (station, 0);
+    }
+  else
+    {
+      mode = GetNonErpSupported (station, 0);
+    }
+  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+  return rtsTxVector;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/aarf-wifi-manager.h ns-3.34/src/wifi/model/rate-control/aarf-wifi-manager.h
--- ns-3.33/src/wifi/model/rate-control/aarf-wifi-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/aarf-wifi-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,81 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2005,2006 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#ifndef AARF_WIFI_MANAGER_H
+#define AARF_WIFI_MANAGER_H
+
+#include "ns3/traced-value.h"
+#include "ns3/wifi-remote-station-manager.h"
+
+namespace ns3 {
+
+/**
+ * \brief AARF Rate control algorithm
+ * \ingroup wifi
+ *
+ * This class implements the AARF rate control algorithm which
+ * was initially described in <i>IEEE 802.11 Rate Adaptation:
+ * A Practical Approach</i>, by M. Lacage, M.H. Manshaei, and
+ * T. Turletti.
+ *
+ * This RAA does not support HT modes and will error
+ * exit if the user tries to configure this RAA with a Wi-Fi MAC
+ * that supports 802.11n or higher.
+ */
+class AarfWifiManager : public WifiRemoteStationManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  AarfWifiManager ();
+  virtual ~AarfWifiManager ();
+
+
+private:
+  void DoInitialize (void) override;
+  WifiRemoteStation * DoCreateStation (void) const override;
+  void DoReportRxOk (WifiRemoteStation *station,
+                     double rxSnr, WifiMode txMode) override;
+  void DoReportRtsFailed (WifiRemoteStation *station) override;
+  void DoReportDataFailed (WifiRemoteStation *station) override;
+  void DoReportRtsOk (WifiRemoteStation *station,
+                      double ctsSnr, WifiMode ctsMode, double rtsSnr) override;
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportFinalRtsFailed (WifiRemoteStation *station) override;
+  void DoReportFinalDataFailed (WifiRemoteStation *station) override;
+  WifiTxVector DoGetDataTxVector (WifiRemoteStation *station) override;
+  WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station) override;
+
+  uint32_t m_minTimerThreshold;   ///< minimum timer threshold
+  uint32_t m_minSuccessThreshold; ///< minimum success threshold
+  double m_successK;              ///< Multiplication factor for the success threshold
+  uint32_t m_maxSuccessThreshold; ///< maximum success threshold
+  double m_timerK;                ///< Multiplication factor for the timer threshold
+
+  TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
+};
+
+} //namespace ns3
+
+#endif /* AARF_WIFI_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/amrr-wifi-manager.cc ns-3.34/src/wifi/model/rate-control/amrr-wifi-manager.cc
--- ns-3.33/src/wifi/model/rate-control/amrr-wifi-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/amrr-wifi-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,405 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2003,2007 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+#include "amrr-wifi-manager.h"
+#include "ns3/wifi-tx-vector.h"
+
+#define Min(a,b) ((a < b) ? a : b)
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("AmrrWifiManager");
+
+/**
+ * \brief hold per-remote-station state for AMRR Wifi manager.
+ *
+ * This struct extends from WifiRemoteStation struct to hold additional
+ * information required by the AMRR Wifi manager
+ */
+struct AmrrWifiRemoteStation : public WifiRemoteStation
+{
+  Time m_nextModeUpdate; ///< next mode update time
+  uint32_t m_tx_ok;      ///< transmit OK
+  uint32_t m_tx_err;     ///< transmit error
+  uint32_t m_tx_retr;    ///< transmit retry
+  uint32_t m_retry;      ///< retry
+  uint8_t m_txrate;      ///< transmit rate
+  uint32_t m_successThreshold; ///< success threshold
+  uint32_t m_success;    ///< success
+  bool m_recovery;       ///< recovery
+};
+
+
+NS_OBJECT_ENSURE_REGISTERED (AmrrWifiManager);
+
+TypeId
+AmrrWifiManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::AmrrWifiManager")
+    .SetParent<WifiRemoteStationManager> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<AmrrWifiManager> ()
+    .AddAttribute ("UpdatePeriod",
+                   "The interval between decisions about rate control changes",
+                   TimeValue (Seconds (1.0)),
+                   MakeTimeAccessor (&AmrrWifiManager::m_updatePeriod),
+                   MakeTimeChecker ())
+    .AddAttribute ("FailureRatio",
+                   "Ratio of minimum erroneous transmissions needed to switch to a lower rate",
+                   DoubleValue (1.0 / 3.0),
+                   MakeDoubleAccessor (&AmrrWifiManager::m_failureRatio),
+                   MakeDoubleChecker<double> (0.0, 1.0))
+    .AddAttribute ("SuccessRatio",
+                   "Ratio of maximum erroneous transmissions needed to switch to a higher rate",
+                   DoubleValue (1.0 / 10.0),
+                   MakeDoubleAccessor (&AmrrWifiManager::m_successRatio),
+                   MakeDoubleChecker<double> (0.0, 1.0))
+    .AddAttribute ("MaxSuccessThreshold",
+                   "Maximum number of consecutive success periods needed to switch to a higher rate",
+                   UintegerValue (10),
+                   MakeUintegerAccessor (&AmrrWifiManager::m_maxSuccessThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("MinSuccessThreshold",
+                   "Minimum number of consecutive success periods needed to switch to a higher rate",
+                   UintegerValue (1),
+                   MakeUintegerAccessor (&AmrrWifiManager::m_minSuccessThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddTraceSource ("Rate",
+                     "Traced value for rate changes (b/s)",
+                     MakeTraceSourceAccessor (&AmrrWifiManager::m_currentRate),
+                     "ns3::TracedValueCallback::Uint64")
+  ;
+  return tid;
+}
+
+AmrrWifiManager::AmrrWifiManager ()
+  : WifiRemoteStationManager (),
+    m_currentRate (0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+AmrrWifiManager::~AmrrWifiManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+AmrrWifiManager::DoInitialize ()
+{
+  NS_LOG_FUNCTION (this);
+  if (GetHtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HT rates");
+    }
+  if (GetVhtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support VHT rates");
+    }
+  if (GetHeSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HE rates");
+    }
+}
+
+WifiRemoteStation *
+AmrrWifiManager::DoCreateStation (void) const
+{
+  NS_LOG_FUNCTION (this);
+  AmrrWifiRemoteStation *station = new AmrrWifiRemoteStation ();
+  station->m_nextModeUpdate = Simulator::Now () + m_updatePeriod;
+  station->m_tx_ok = 0;
+  station->m_tx_err = 0;
+  station->m_tx_retr = 0;
+  station->m_retry = 0;
+  station->m_txrate = 0;
+  station->m_successThreshold = m_minSuccessThreshold;
+  station->m_success = 0;
+  station->m_recovery = false;
+  return station;
+}
+
+void
+AmrrWifiManager::DoReportRxOk (WifiRemoteStation *station,
+                               double rxSnr, WifiMode txMode)
+{
+  NS_LOG_FUNCTION (this << station << rxSnr << txMode);
+}
+
+void
+AmrrWifiManager::DoReportRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void
+AmrrWifiManager::DoReportDataFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
+  station->m_retry++;
+  station->m_tx_retr++;
+}
+
+void
+AmrrWifiManager::DoReportRtsOk (WifiRemoteStation *st,
+                                double ctsSnr, WifiMode ctsMode, double rtsSnr)
+{
+  NS_LOG_FUNCTION (this << st << ctsSnr << ctsMode << rtsSnr);
+}
+
+void
+AmrrWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                 double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
+{
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
+  station->m_retry = 0;
+  station->m_tx_ok++;
+}
+
+void
+AmrrWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void
+AmrrWifiManager::DoReportFinalDataFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
+  station->m_retry = 0;
+  station->m_tx_err++;
+}
+
+bool
+AmrrWifiManager::IsMinRate (AmrrWifiRemoteStation *station) const
+{
+  NS_LOG_FUNCTION (this << station);
+  return (station->m_txrate == 0);
+}
+
+bool
+AmrrWifiManager::IsMaxRate (AmrrWifiRemoteStation *station) const
+{
+  NS_LOG_FUNCTION (this << station);
+  NS_ASSERT (station->m_txrate + 1 <= GetNSupported (station));
+  return (station->m_txrate + 1 == GetNSupported (station));
+}
+
+bool
+AmrrWifiManager::IsSuccess (AmrrWifiRemoteStation *station) const
+{
+  NS_LOG_FUNCTION (this << station);
+  return (station->m_tx_retr + station->m_tx_err) < station->m_tx_ok * m_successRatio;
+}
+
+bool
+AmrrWifiManager::IsFailure (AmrrWifiRemoteStation *station) const
+{
+  NS_LOG_FUNCTION (this << station);
+  return (station->m_tx_retr + station->m_tx_err) > station->m_tx_ok * m_failureRatio;
+}
+
+bool
+AmrrWifiManager::IsEnough (AmrrWifiRemoteStation *station) const
+{
+  NS_LOG_FUNCTION (this << station);
+  return (station->m_tx_retr + station->m_tx_err + station->m_tx_ok) > 10;
+}
+
+void
+AmrrWifiManager::ResetCnt (AmrrWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  station->m_tx_ok = 0;
+  station->m_tx_err = 0;
+  station->m_tx_retr = 0;
+}
+
+void
+AmrrWifiManager::IncreaseRate (AmrrWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  station->m_txrate++;
+  NS_ASSERT (station->m_txrate < GetNSupported (station));
+}
+
+void
+AmrrWifiManager::DecreaseRate (AmrrWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  station->m_txrate--;
+}
+
+void
+AmrrWifiManager::UpdateMode (AmrrWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  if (Simulator::Now () < station->m_nextModeUpdate)
+    {
+      return;
+    }
+  station->m_nextModeUpdate = Simulator::Now () + m_updatePeriod;
+  NS_LOG_DEBUG ("Update");
+
+  bool needChange = false;
+
+  if (IsSuccess (station) && IsEnough (station))
+    {
+      station->m_success++;
+      NS_LOG_DEBUG ("++ success=" << station->m_success << " successThreshold=" << station->m_successThreshold <<
+                    " tx_ok=" << station->m_tx_ok << " tx_err=" << station->m_tx_err << " tx_retr=" << station->m_tx_retr <<
+                    " rate=" << +station->m_txrate << " n-supported-rates=" << +GetNSupported (station));
+      if (station->m_success >= station->m_successThreshold
+          && !IsMaxRate (station))
+        {
+          station->m_recovery = true;
+          station->m_success = 0;
+          IncreaseRate (station);
+          needChange = true;
+        }
+      else
+        {
+          station->m_recovery = false;
+        }
+    }
+  else if (IsFailure (station))
+    {
+      station->m_success = 0;
+      NS_LOG_DEBUG ("-- success=" << station->m_success << " successThreshold=" << station->m_successThreshold <<
+                    " tx_ok=" << station->m_tx_ok << " tx_err=" << station->m_tx_err << " tx_retr=" << station->m_tx_retr <<
+                    " rate=" << +station->m_txrate << " n-supported-rates=" << +GetNSupported (station));
+      if (!IsMinRate (station))
+        {
+          if (station->m_recovery)
+            {
+              station->m_successThreshold *= 2;
+              station->m_successThreshold = std::min (station->m_successThreshold,
+                                                      m_maxSuccessThreshold);
+            }
+          else
+            {
+              station->m_successThreshold = m_minSuccessThreshold;
+            }
+          station->m_recovery = false;
+          DecreaseRate (station);
+          needChange = true;
+        }
+      else
+        {
+          station->m_recovery = false;
+        }
+    }
+  if (IsEnough (station) || needChange)
+    {
+      NS_LOG_DEBUG ("Reset");
+      ResetCnt (station);
+    }
+}
+
+WifiTxVector
+AmrrWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
+  UpdateMode (station);
+  NS_ASSERT (station->m_txrate < GetNSupported (station));
+  uint8_t rateIndex;
+  if (station->m_retry < 1)
+    {
+      rateIndex = station->m_txrate;
+    }
+  else if (station->m_retry < 2)
+    {
+      if (station->m_txrate > 0)
+        {
+          rateIndex = station->m_txrate - 1;
+        }
+      else
+        {
+          rateIndex = station->m_txrate;
+        }
+    }
+  else if (station->m_retry < 3)
+    {
+      if (station->m_txrate > 1)
+        {
+          rateIndex = station->m_txrate - 2;
+        }
+      else
+        {
+          rateIndex = station->m_txrate;
+        }
+    }
+  else
+    {
+      if (station->m_txrate > 2)
+        {
+          rateIndex = station->m_txrate - 3;
+        }
+      else
+        {
+          rateIndex = station->m_txrate;
+        }
+    }
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  WifiMode mode = GetSupported (station, rateIndex);
+  if (m_currentRate != mode.GetDataRate (channelWidth))
+    {
+      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
+      m_currentRate = mode.GetDataRate (channelWidth);
+    }
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+}
+
+WifiTxVector
+AmrrWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  UpdateMode (station);
+  WifiTxVector rtsTxVector;
+  WifiMode mode;
+  if (GetUseNonErpProtection () == false)
+    {
+      mode = GetSupported (station, 0);
+    }
+  else
+    {
+      mode = GetNonErpSupported (station, 0);
+    }
+  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+  return rtsTxVector;
+}
+
+} //namespace ns3
